#ifndef AG_STRING_H
#define AG_STRING_H

#include "agabt.h"
#include <string>
/*
 * The AGCLIB1 Class Library, Version 1.0
 * Copyright (c) Parsifal Software, 2001. All Rights Reserved.
 * http://www.parsifalsoft.com
*/

// Implementation of the AgString class by derivation from sdt::string

struct AgString : public std::string {
  AgString() : std::string() {}
  AgString(const char *s) : std::string(s) {}
  AgString(const std::string &s) : std::string(s) {}
  operator const char *() const {return c_str();}
  AgString &append(int c) { *this += (char) c; return *this;}
  AgString &append(const char *s) {*this += s; return *this;}
  AgString &append(const char *s, int n) {*this += std::string(s, n); return *this;}
};

inline int agABTHash(AgString &s, int hashcode = 0) {
  return agABTHash(s.c_str(), hashcode);
}

#endif
